from pynovatec.events import EventListener
from pynovatec_compute.batchers import RawBatchDataEvent
import os

class BatchSaver(EventListener):                                
    def __init__(self,path, *args,**kwargs):                                 
        super().__init__(*args,**kwargs)
        self.path = path
        self.events.append(RawBatchDataEvent)                          
        self.register()                                                

    def get_dir_name(self,duration):
        dirname = os.path.join(self.path,str(duration))
        if not os.path.exists(dirname):
            os.makedirs(dirname)
        return dirname
    
    def write_raw_data(self,data,timestamp,duration):
        filename = os.path.join(self.get_dir_name(duration),str(timestamp)+".csv") 
        file = open(filename,'w')
        for line in data:
            file.write(line+"\n")
        file.close()
                                                                  
    def handle(self,msg):                                              
        raw_data_list = msg.data['data']                               
        duration = msg.data['duration']       
        timestamp = msg.data['timestamp']                        
        try: 
          self.write_raw_data(raw_data_list,timestamp,duration)                                                          
        except Exception as e:                                                                          
          error_str = "BatchListener Exception: " + str(e)                                              
          print(error_str)                                                                              
          print(traceback.format_exc())                                                                 

