from os import getenv as env
import copy
from pynovatec.helpers import read_json_from_file
import time

g_custom_header_items = {}
g_machine_details_file = None
g_input_json_template = None
g_LstSubAssemblyInstances = None

def make_pa_input_json_init(machine_details_file, custom_header={}):
    global g_custom_header_items
    global g_machine_details_file

    g_custom_header_items = custom_header
    g_machine_details_file = machine_details_file

def make_header_template(json_data):
    header = {
        'firmware': env('VERSION','unknown'),
        'companyName' : json_data['zone']['location']['company']['name'],
        'assemblyId' : json_data['models']['assemblyId'],
        'machineName' : json_data['name'],
        'manufacturer' : json_data['category'],
        'modelName' : json_data['models']['name'],
        'companyId' : json_data['zone']['location']['company']['id'],
        'machineId' : json_data['sensorAssignments'][0]['machineId'],
        'assemblyName' : json_data['models']['assembly']['name'],
    #  'host' : appconfig.host,
        'zoneId' : json_data['zone']['id'],
        'gaugeDuration' : '600',
        'zoneName' : json_data['zone']['name'],
        'qc_profile' : 'null',
        'timestamp' : int(time.time()),
        'group' : json_data['group']
    }
    header.update(g_custom_header_items)
    return header

def make_subassemblies_template(subAssemblyInstances):
    global g_LstSubAssemblyInstances

    subassemblies_template = {}
    LstSubAssemblyInstances = []
    LstSubAssemblyInstances.insert(0, 'null')

    if (str(subAssemblyInstances[0]['subAssembly']['name']).find('vfd') == -1):
        print("Top if")
        for loop_counter in range (len(subAssemblyInstances)):
          LstSubAssemblyInstances.insert(int(subAssemblyInstances[loop_counter]['name'][-1]), \
          subAssemblyInstances[loop_counter]['name'])

          json_part = {subAssemblyInstances[loop_counter]['name'] : \
                  {'collectors' : {subAssemblyInstances[loop_counter]['subAssembly']['collectors'][0]['name'] : \
                  {'CSV_4' : [[]], 'CSV_6' : [[]], 'CSV_10' : [[]], 'CSV_20' : [[]], 'CSV_24' : [[]], 'CSV_28' : [[]], 'CSV_32' : [[]]}}, 'header' : \
                  {'subAssembly' : {'name' : subAssemblyInstances[loop_counter]['subAssembly']['name']}}}}

          subassemblies_template.update(json_part)

    else:
        print("Top else")
        LstSubAssemblyInstances.insert(1, 'vfdinput1')
        LstSubAssemblyInstances.insert(2, 'vfdoutput1')
        json_part = {'vfdoutput1' : {'collectors' : {'pf1' : {'CSV_4' : [[]], 'CSV_6' : [[]], 'CSV_10' : [[]]}}, 'header' : {'subAssembly' : {'name' : 'vfdOutput'}}}}
        subassemblies_template.update(json_part)
        json_part = {'vfdinput1' : {'collectors' : {'pf1' : {'CSV_4' : [[]], 'CSV_6' : [[]], 'CSV_10' : [[]], 'CSV_20' : [[]]}}, 'header' : {'subAssembly' : {'name' : 'vfdInput'}}}}
        subassemblies_template.update(json_part)

    g_LstSubAssemblyInstances = LstSubAssemblyInstances
    return subassemblies_template

def make_pa_input_json_template(machine_details_file):
    json_data = read_json_from_file(machine_details_file)
    template = {}
    template['header'] = make_header_template(json_data)
    template['subassemblies'] = make_subassemblies_template(json_data['models']['assembly']['subAssemblyInstances'])
    return template

# This is a bit kludgie for now, but will serve as a wrapper until I can fix it later.
# g_ListSubAssemblyInstances needs to be handled more gracefully somehow.

def get_LstSubAssemblyInstances():
    global g_LstSubAssemblyInstances
    if g_LstSubAssemblyInstances is None:
        get_input_json_template()
    return g_LstSubAssemblyInstances

def get_input_json_template():
    global g_input_json_template

    if g_input_json_template is None:
        g_input_json_template = make_pa_input_json_template(g_machine_details_file)
    return copy.deepcopy(g_input_json_template)
