from es.ps_input_json_creator import init,run
from pynovatec import appconfig
from pathlib import Path
import json
import sys
import getopt

conf_file_path = 'es/confs/input_json_creator.local.jsonX'

def load_config(config_file):
    conf_file_exist = Path(config_file)
    if conf_file_exist.is_file() == False:
         print('No such file ' + config_file);
         #msg_log('IJC~~~No such file ' + config_file+ ' ' + str(round(time.time())))
         sys.exit()
    with open (config_file) as conf_json_file:
        conf_json_data = json.load(conf_json_file)
    appconfig.add(**conf_json_data)

batch_saver = False
batch_mode = "zmq"
ramcsv_path = "/tmp/ramcsv"

try:
    opts, args = getopt.getopt(sys.argv[1:],"c:B:b:r:")
    #print("opts is: ",opts)
except getopt.GetoptError:
    print("Error: Error Loading Configuration Details: ")
for opt,arg in opts:
    #print("opt is: ",opt)
    if opt == "-c":
        conf_file_path = arg
    if opt == "-B":
        batch_saver = arg
    if opt == "-b":
        batch_mode = arg
    if opt == "-r":
        ramcsv_path = arg



load_config(conf_file_path)
init(appconfig)
appconfig.batch_saver = batch_saver
appconfig.batch_mode = batch_mode
appconfig.ramcsv_path = ramcsv_path
run()




